#!/bin/env python
# -*- coding: utf-8 -*-

# ------------------------------------------------------------
# opensecurityd
#   
# the opensecurityd as RESTful server
#
# Autor: Mihai Bartha, <mihai.bartha@ait.ac.at>       
#
# Copyright (C) 2013 AIT Austrian Institute of Technology
# AIT Austrian Institute of Technology GmbH
# Donau-City-Strasse 1 | 1220 Vienna | Austria
# http://www.ait.ac.at
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation version 2.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, 
# Boston, MA  02110-1301, USA.
# ------------------------------------------------------------


# ------------------------------------------------------------
# imports

import unittest

import os
import re
import os.path
import sys
import cygwin
import vmmanager
import _winreg
gvm_mgr = None

class TestVMManager(unittest.TestCase):
    
    def setUp(self):
        pass
    
    @classmethod
    def setUpClass(self):
        global gvm_mgr
        gvm_mgr = vmmanager.VMManager.getInstance()
        pass
    
    @unittest.skip("skipping")
    def testGetTemplateUUID(self):
        template = vmmanager.VMManager.getTemplateUUID()
        self.assertIsNotNone(template,  "returned no UUID for template")
    
    @unittest.skip("skipping")    
    def testUpdateTemplate(self):
        gvm_mgr.updateTemplate()
        pass
    
    def setKey(self, key, name, value):
        _, reg_type = _winreg.QueryValueEx(key, name)
        _winreg.SetValueEx(key, name, 0, reg_type, value)
    
    @unittest.skip("skipping")    
    def testGetProxySettings(self):
        #sudo echo "http_proxy=http://80.122.169.38:8080/" >> /etc/environment
        aReg = _winreg.ConnectRegistry(None,_winreg.HKEY_CURRENT_USER)
        aKey = _winreg.OpenKey(aReg, r"Software\Microsoft\Windows\CurrentVersion\Internet Settings")
        subCount, valueCount, lastModified = _winreg.QueryInfoKey(aKey)
        proxy = dict()
        for i in range(valueCount):                                           
            try:
                n,v,t = _winreg.EnumValue(aKey,i)
                proxy[n] = v
            except EnvironmentError:                                               
                break
        _winreg.CloseKey(aKey)
        print proxy
        if 'ProxyEnable' in proxy.keys() and proxy['ProxyEnable'] == 1:
            print proxy['ProxyServer']
            return proxy['ProxyServer']
        else: 
            return ""
    
    @unittest.skip("skipping")      
    def testMatchProxy(self):
        #http=212.17.86.109:8080;https=212.17.86.109:8080;ftp=212.17.86.109:8080
        #212.17.86.109:8080
        text = 'http=212.17.86.109:8080;https=212.17.86.109:8080;ftp=212.17.86.109:8080'
        print re.search(r"(?<=http=)(?P<HttpProxy>.*?)(?=;)", text).groupdict()
        print re.search(r"(?<=http=)(.*?)(?=;)", text)
        
    #@classmethod
    #def tearOffClass(self):
    #    gvm_mgr.stop()
    #    gvm_mgr.cleanup()
    
    
    #VBoxManage list hostonlyifs
    #VBoxManage list dhcpservers
    #VBoxManage dhcpserver remove --netname "HostInterfaceNetworking-VirtualBox Host-Only Ethernet Adapter"
    #VBoxManage dhcpserver add --ifname "VirtualBox Host-Only Ethernet Adapter" --ip 192.168.56.100 --netmask 255.255.255.0 --lowerip 192.168.56.101 --upperip 192.168.56.254 --enable
    #VBoxManage dhcpserver modify --ifname "VirtualBox Host-Only Ethernet Adapter" --enable
    #VBoxManage hostonlyif ipconfig "VirtualBox Host-Only Ethernet Adapter" --dhcp
    #VBoxManage hostonlyif ipconfig "VirtualBox Host-Only Ethernet Adapter" --ip 192.168.56.1 --netmask 255.255.255.0

    
    
    def testHostOnlyDHCP(self):
        #list hostonlyifs
        #Cygwin.vboxExecute("list hostonlyifs")
        
        hostonlyifs = gvm_mgr.getHostOnlyIFs()
        print hostonlyifs
        
        dhcpservers = gvm_mgr.getDHCPServers()
        print dhcpservers
        
if __name__ == '__main__':
    TestVMManager.setUpClass()
    
    suite = unittest.TestLoader().loadTestsFromTestCase(TestVMManager)
    unittest.TextTestRunner().run(suite)
    
#    logger = setupLogger('Cygwin')
#    c = Cygwin()
#    unittest.main()
    #man = VMManager.getInstance()
    #man.listVM()
    #print man.getConnectedRSDs()
    #print man.getNetworkDrives()
    #man.genNetworkDrive()
    #drive_bitmask = ctypes.cdll.kernel32.GetLogicalDrives()
    #print list(itertools.compress(string.ascii_uppercase,  map(lambda x:ord(x) - ord('0'), bin(drive_bitmask)[:1:-1])))
    #print list(map(chr, range(68, 91))) 
    #print Cygwin.getRegEntry('SYSTEM\CurrentControlSet\Enum\USB', 'VID_1058&PID_0704')[0]
    #devices = VMManager.getConnectedRSDS()
    #print devices
    
    #drives = VMManager.getLogicalDrives()
    #print drives
    #print VMManager.getDriveType("E")
    #print VMManager.getVolumeInfo("E")
    #print VMManager.getNetworkPath("E")
    
    #vmm.backupFile()
    #for device in devices.values():
    #    #print device
    #    if VMManager.isMassStorageDevice(device):
    #        print device
        
    
    
    #time.sleep(-1)
    #man.listVM()
    #man.listVM()
    #man.listVM()
    #man.listVM()
    #man.genCertificateISO('SecurityDVM0')
    #man.guestExecute('SecurityDVM0', '/bin/ls -la')
    #logger = setupLogger('VMManager')
    #c = Cygwin()
    
    #man.sshExecute('/bin/ls -la', 'SecurityDVM0')
    #man.sshExecuteX11('/usr/bin/iceweasel', 'SecurityDVM0')
    #man.removeVM('SecurityDVM0')
    #man.netUse('192.168.56.134', 'USB\\')
    #ip = '192.168.56.139'
    
    #man.cygwin_path = 'c:\\cygwin64\\bin\\'
    #man.handleDeviceChange()
    #print man.listSDVM()
    #man.configureHostNetworking()
    #new_vm = man.generateSDVMName()
    #man.createVM(new_vm)
    
    #print Cygwin.cmd()
    #man.isAvailable('c:')
    #ip = man.getHostOnlyIP('SecurityDVM0')
    #man.mapNetworkDrive('h:', '\\\\' + ip + '\Download', None, None)
    
    #man.genCertificateISO(new_vm)
    #man.attachCertificateISO(new_vm)
    
    #man.attachCertificateISO(vm_name)
    #man.guestExecute(vm_name, "ls")
    #man.sshGuestX11Execute('SecurityDVM1', '/usr/bin/iceweasel')
    #time.sleep(60)
    #print man.cygwinPath("C:\Users\BarthaM\VirtualBox VMs\SecurityDVM\.ssh\*")
    #man.genCertificateISO('SecurityDVM')
    #man.attachCertificateISO('SecurityDVM')
    #man.isStorageAttached('SecurityDVM')
    #man.guestExecute('SecurityDVM', 'sudo apt-get -y update')
    #man.guestExecute('SecurityDVM', 'sudo apt-get -y upgrade' )
    
    #man.stopVM('SecurityDVM')
    #man.detachStorage('SecurityDVM')
    #man.changeStorageType('C:\Users\BarthaM\VirtualBox VMs\SecurityDVM\SecurityDVM.vmdk','immutable')
    #man.storageAttach('SecurityDVM')
    
    
    #cmd = "c:\\cygwin64\\bin\\bash.exe --login -c \"/bin/ls\""
    #man.execute(cmd)